{$ifdef osf1}
  [environment ('bx_dev.pen'), inherit ('dep_dec.pen','bx_types.pen')]
  module bx_dev(input,output);
{$endif}

{$ifdef vms}
  [environment ('bx_dev.pen'), inherit ('dep_vms.pen','bx_types.pen')]
  module bx_dev(input,output);
{$endif}

{$ifdef Borland_Pascal}

unit bx_dev;

INTERFACE

uses crt,dep_tp,bx_types;

procedure ask_ansi;

procedure menu_ansi(var pre       : prestring;
                    var lc        : boolean;
                        txt       : txtstring;
                        parstring : parstringtype);
			
procedure ansi     (    action    : actiontype;
                    var xpos,ypos : real;
                        c         : char;
                        colno     : integer);
procedure ask_crt;

procedure menu_crt( var crtrec          : crtrecord;
                    var lc              : boolean;
                        txt             : txtstring;
                        parstring       : parstringtype);

procedure crtout  (    action           : actiontype;
                   var xpos,ypos        : real;
                       c                : char;
                       colno            : integer);

procedure ask_rtf;

procedure menu_rtf( var rtfrec          : rtfrecord;
                    var lc              : boolean;
                        txt             : txtstring;
                        parstring       : parstringtype);

procedure rtf     (    action           : actiontype;
                   var xpos,ypos        : real;
                       c                : char;
                       colno            : integer);


procedure ask_postscript;

procedure menu_postscript( var ps          : psrecord;
                           var lc          : boolean;
                           txt             : txtstring;
                           parstring       : parstringtype);
			   
procedure postscript  (    action          : actiontype;
                       var xpos,ypos       : real;
                           c               : char;
                           colno           : integer);
			   
procedure eps         (    action          : actiontype;
                       var xpos,ypos       : real;
                           c               : char;
                           colno           : integer);

procedure ask_hpgl;

procedure menu_hpgl      ( var hpglrec     : hpglrecord;
                           var lc          : boolean;
                           txt             : txtstring;
                           parstring       : parstringtype);
			   
procedure hpgl  (          action          : actiontype;
                       var xpos,ypos       : real;
                           c               : char;
                           colno           : integer);

procedure ask_lj250;

procedure menu_lj250(var pre       : prestring;
                     var lc        : boolean;
                         txt       : txtstring;
                         parstring : parstringtype);

procedure lj250     (    action    : actiontype;
                     var xpos,ypos : real;
                         c         : char;
                         colno     : integer);

procedure ask_regis;

procedure menu_regis( var regstr      : regisstring;
                      var lc          : boolean;
                      txt             : txtstring;
                      parstring       : parstringtype);

procedure regis        (    action    : actiontype;
                        var xpos,ypos : real;
                            c         : char;
                            colno     : integer;
                            regmode   : regmodetype);


procedure ask_vt;

procedure menu_vt(var pre       : prestring;
                  var lc        : boolean;
                      txt       : txtstring;
                      parstring : parstringtype);

procedure vt     (    action    : actiontype;
                  var xpos,ypos : real;
                      c         : char;
                      colno     : integer);


IMPLEMENTATION


{$endif} {Borland_Pascal}

  {------------------------------------}
  {   ANSI-Terminal specific section   }
  {------------------------------------}

procedure menu_ansi(var pre       : prestring;
                    var lc        : boolean;
                        txt       : txtstring;
                        parstring : parstringtype);
			
var code     : char;
    instring : string40;
begin
  if interactflag then begin
    writeln;
    writeln('-------------------------------------------------------------');
    writeln('Enter the text attributes for printing of >',txt,'< residues:');
    writeln('Different letters specify renditions,');
    writeln('lowercase choices mean lowercase residues:');
    writeln('(N,n) normal    (B,b) bold   (U,u) underscore  (R,r) reverse');
    writeln('(F,f) flashing  (E,e) reverse/bold (L,l) reverse/flashing');
    writeln;
    write('choose from NnBbUuRrFfEeLl ( * ',parstring[1],' * ) : ');
    readln(instring);
  end else instring:='';
  if instring='' then code:=parstring[1] else code:=instring[1];
  if code=upcase(code) then lc:=false else lc:=true;
  code:=upcase(code);
  case code of
   'N' : pre:= chr(27)+'[0m';
   'B' : pre:= chr(27)+'[0;1m';
   'U' : pre:= chr(27)+'[0;4m';
   'R' : pre:= chr(27)+'[0;7m';
   'E' : pre:= chr(27)+'[0;1;7m';
   'L' : pre:= chr(27)+'[0;5;7m';
   'F' : pre:= chr(27)+'[0;5m';
  end;
end;

procedure ask_ansi;
var parstring : parstringtype;
begin
  reset(parfile);
  repeat readln(parfile,line) until indx(line,':ANSI')=1;
  if interactflag then
    writeln('-------------------------------------------------------------');
  pre_reset:=chr(27)+'[0m';
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  menu_ansi(pre[0],lc[0],'normal',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  menu_ansi(pre[1],lc[1],'identical',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  if simflag then begin
    menu_ansi(pre[2],lc[2],'similar',parstring)
  end else begin
    pre[2]:=pre[0];
    lc[2]:=lc[0];
  end;
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  if globalflag then begin
    menu_ansi(pre[3],lc[3],'conserved',parstring)
  end else begin
    pre[3]:=pre[1];
    lc[3]:=lc[1];
  end;
  if not cloutflag then begin
    write('filename for ANSI-output (return for terminal)  : ');
    readln(outname);
  end;
end;

procedure ansi     (    action    : actiontype;
                    var xpos,ypos : real;
                        c         : char;
                        colno     : integer);
begin
  case action of
  init : begin
           fopen(outfile,outname,'w');
           write(outfile,chr(27)+'[2J'+chr(27)+'[0;0H');
           write(outfile,pre_reset);
           dev_minx:=0;
           dev_miny:=1;
           dev_maxx:=80;
           dev_maxy:=25;
           dev_xsize:=1;
           dev_ysize:=1;
           xpos:=dev_minx;
           ypos:=dev_miny;
         end;
  setcol : begin
             write(outfile,pre[colno]);
           end;
  charout : begin
              write(outfile,c);
              xpos:=xpos+dev_xsize;
            end;
  newline : begin
              uwriteln(outfile,pre_reset);
              xpos:=dev_minx;
              ypos:=ypos+dev_ysize;
            end;
  newpage : begin
              writeln(chr(7));
              readln;
              xpos:=dev_minx;
              ypos:=dev_miny;
            end;
  exit    : begin
              uwriteln(outfile,pre_reset);
              close(outfile);
            end;
  end;
end;

  {----------------------------------------}
  {   CRT  specific section ***** NOT SUPPORTED FOR DECpascal ****** }
  {----------------------------------------}

{$ifdef Borland_Pascal}

procedure menu_crt( var crtrec          : crtrecord;
                    var lc              : boolean;
                        txt             : txtstring;
                        parstring       : parstringtype);

var p        : integer;
    code     : char;
    instring : string40;

begin
  if interactflag then begin
    writeln;
    writeln('-------------------------------------------------------------');
    writeln('Enter the text attributes for printing of ***>',txt,'<*** residues:');
    writeln('First choose the color/gray-value of the letter ***>background<***');
    writeln('Different letters specify different colors,');
    writeln('(R) red     (G) green         (U) blue ');
    writeln('(B) black   (L) light gray');
    writeln;
    write('choose from  RGUYDL ( * ',parstring[1],' * ) : ');
    readln(instring);
  end else instring:='';
  if instring='' then code:=parstring[1] else code:=instring[1];
  code:=upcase(code);
  case code of
  'B' : crtrec.bgnd:=black;
  'R' : crtrec.bgnd:=red;
  'G' : crtrec.bgnd:=green;
  'U' : crtrec.bgnd:=blue;
  'L' : crtrec.bgnd:=lightgray;
  end;
  if interactflag then begin
    writeln;
    writeln;
    writeln('Now choose the color/gray-value of the letter **>foreground<**');
    writeln('lowercase choices mean lowercase letters in the sequence:');
    writeln('(R,r) red    (G,g) green  (U,u) blue        (Y,y) yellow');
    writeln('(B,b) black  (W,w) white  (D,d) dark gray   (L,l) light gray');
    writeln;
    write('choose from  RrGgUuYyBbWwDdLl ( * ',parstring[2],' * ) : ');
    readln(instring);
  end else instring:='';
  if instring='' then code:=parstring[2] else code:=instring[1];
  if code=upcase(code) then lc:=false else lc:=true;
  code:=upcase(code);
  case code of
  'B' : crtrec.fgnd:=black;
  'W' : crtrec.fgnd:=white;
  'R' : crtrec.fgnd:=red;
  'G' : crtrec.fgnd:=green;
  'U' : crtrec.fgnd:=blue;
  'Y' : crtrec.fgnd:=yellow;
  'D' : crtrec.fgnd:=darkgray;
  'L' : crtrec.fgnd:=lightgray;
  end; 
end;

procedure ask_crt;
var parstring : parstringtype;
    instring  : string40;
    nametag   : string10;
begin
  if interactflag then
    writeln('-------------------------------------------------------------');
  reset(parfile);
  nametag:=':CRT';
  repeat readln(parfile,line) until indx(line,':CRT')=1;
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  menu_crt(crtrec[0],lc[0],'normal',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  menu_crt(crtrec[1],lc[1],'identical',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  if simflag then menu_crt(crtrec[2],lc[2],'similar',parstring) else begin
    crtrec[2]:=crtrec[0];
    lc[2]:=lc[0];
  end;
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  if globalflag then menu_crt(crtrec[3],lc[3],'conserved',parstring)
  else begin
    crtrec[3]:=crtrec[1];
    lc[3]:=lc[1];
  end;
end;

procedure crtout  (    action           : actiontype;
                   var xpos,ypos        : real;
                       c                : char;
                       colno            : integer);

begin
  case action of
  init : begin
           dev_minx:=0;
           dev_miny:=1;
           dev_maxx:=80;
           dev_maxy:=25;
           dev_xsize:=1;
           dev_ysize:=1;
           xpos:=dev_minx;
           ypos:=dev_maxy;
           textbackground(crtrec[0].bgnd);
           textcolor(crtrec[0].fgnd);
           clrscr;
         end;
  setcol : begin
             textbackground(crtrec[colno].bgnd);
             textcolor(crtrec[colno].fgnd);
           end;
  charout : begin
              write(c);
              xpos:=xpos+dev_xsize;
            end;
  newline : begin
              textbackground(crtrec[0].bgnd);
              textcolor(crtrec[0].fgnd);
              writeln;
              xpos:=dev_minx;
              ypos:=ypos-dev_ysize;
            end;
  newpage : begin
              readln;
              xpos:=dev_minx;
              ypos:=dev_miny;
            end;
  exit    : begin
              normvideo;
            end;
  end;
end; 

{$endif} {Borland_Pascal}

  {----------------------------------------}
  {   RTF  specific section                }
  {----------------------------------------}

procedure menu_rtf( var rtfrec          : rtfrecord;
                    var lc              : boolean;
                        txt             : txtstring;
                        parstring       : parstringtype);

var code     : char;
    instring : string40 ;

begin
  if interactflag then begin
    writeln;
    writeln('-------------------------------------------------------------');
    writeln('Enter the text attributes for printing of ***>',txt,'<*** residues:');
    writeln('First choose the color/gray-value of the letter ***>background<***');
    writeln('Different letters specify different colors,');
    writeln('!! Background colors are not supported on most RTF-programs !!');
    writeln('(R) red     (G) green   (B) blue   (C) cyan');
    writeln('(M) magenta (Y) yellow  (K) black  (W) white  (L) light gray');
    writeln;
    write('choose from  RGBCMYKWL ( * ',parstring[1],' * ) : ');
    readln(instring);
  end else instring:='';
  if instring='' then code:=parstring[1] else code:=instring[1];
  code:=upcase(code);
  case code of
  'R' : rtfrec.bgnd:=2;
  'G' : rtfrec.bgnd:=3;
  'B' : rtfrec.bgnd:=4;
  'C' : rtfrec.bgnd:=5;
  'M' : rtfrec.bgnd:=6;
  'Y' : rtfrec.bgnd:=7;
  'K' : rtfrec.bgnd:=0;
  'W' : rtfrec.bgnd:=1;
  'L' : rtfrec.bgnd:=8;
  end;
  if interactflag then begin
    writeln;
    writeln;
    writeln('Now choose the color/gray-value of the letter ***>foreground<***');
    writeln('lowercase choices mean lowercase letters in the sequence:');
    writeln('(R) red     (G) green   (B) blue   (C) cyan');
    writeln('(M) magenta (Y) yellow  (K) black  (W) white  (L) light gray');
    writeln;
    write('choose from  RrGgBbCcMmYyKkWwLl ( * ',parstring[2],' * ) : ');
    readln(instring);
  end else instring:='';
  if instring='' then code:=parstring[2] else code:=instring[1];
  if code=upcase(code) then lc:=false else lc:=true;
  code:=upcase(code);
  case code of
  'R' : rtfrec.fgnd:=2;
  'G' : rtfrec.fgnd:=3;
  'B' : rtfrec.fgnd:=4;
  'C' : rtfrec.fgnd:=5;
  'M' : rtfrec.fgnd:=6;
  'Y' : rtfrec.fgnd:=7;
  'K' : rtfrec.fgnd:=0;
  'W' : rtfrec.fgnd:=1;
  'L' : rtfrec.fgnd:=8;
  end;
end;

procedure ask_rtf;
var parstring : parstringtype;
    instring  : string40 ;
begin
  if interactflag then
    writeln('-------------------------------------------------------------');
  reset(parfile);
  repeat readln(parfile,line) until indx(line,':RTF')=1;
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  menu_rtf(rtfrec[0],lc[0],'normal',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  menu_rtf(rtfrec[1],lc[1],'identical',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  if simflag then menu_rtf(rtfrec[2],lc[2],'similar',parstring) else begin
    rtfrec[2]:=rtfrec[0];
    lc[2]:=lc[0];
  end;
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  if globalflag then menu_rtf(rtfrec[3],lc[3],'conserved',parstring)
  else begin
    rtfrec[3]:=rtfrec[1];
    lc[3]:=lc[1];
  end;
  readln(parfile,rtfcell);
  if interactflag then begin
    repeat
      write('Character size in Points ( * ',rtfcell:2,' * ) : ');
      readln(instring);
      if instring<>'' then rtfcell:=str2int(instring);
    until (rtfcell>=1) and (rtfcell<=40);
  end;
  if not cloutflag then begin
    write('filename for RTF-output  : ');
    readln(outname);
  end;
end;

procedure rtf     (    action           : actiontype;
                   var xpos,ypos        : real;
                       c                : char;
                       colno            : integer);
begin
  case action of
  init : begin
           dev_minx:=0;
           dev_miny:=1;
           dev_maxx:=10480;
           dev_maxy:=15000;
           dev_xsize:=rtfcell*20*6/10;
           dev_ysize:=rtfcell*20;
           xpos:=dev_minx;
           ypos:=dev_maxy;
{          textbackground(rtfrec[0].bgnd);
           textcolor(rtfrec[0].fgnd);    ***** What are these good for?? ***}
           fopen(outfile,outname,'w');
           uwriteln(outfile,'{\rtf1\ansi\deff0');
           uwriteln(outfile,'{\fonttbl{\f0\fmodern Courier;}}');
           uwriteln(outfile,'{\colortbl');
           write(outfile,'\red0\green0\blue0;');
           write(outfile,'\red255\green255\blue255;');
           write(outfile,'\red255\green0\blue0;');
           write(outfile,'\red0\green255\blue0;');
           write(outfile,'\red0\green0\blue255;');
           write(outfile,'\red0\green255\blue255;');
           write(outfile,'\red255\green0\blue255;');
           write(outfile,'\red255\green255\blue0;');
           uwriteln(outfile,'\red128\green128\blue128;}');
           uwriteln(outfile,'\paperw11880\paperh16820\margl1000\margr500');
           uwriteln(outfile,'\margt910\margb910\sectd\cols1\pard\plain');
           if rtfcell<5 then
             uwriteln(outfile,'\fs'+int2str(2*rtfcell,1))
           else
             uwriteln(outfile,'\fs'+int2str(2*rtfcell,2));
         end;
  setcol : begin
             write(outfile,'\cb',rtfrec[colno].bgnd:1,' ');
             write(outfile,'\cf',rtfrec[colno].fgnd:1,' ');
           end;
  charout : begin
              write(outfile,c);
              xpos:=xpos+dev_xsize;
            end;
  newline : begin
              write(outfile,'\cb',rtfrec[0].bgnd:1,' ');
              write(outfile,'\cf',rtfrec[0].fgnd:1,' ');
              uwriteln(outfile,'\line');
              xpos:=dev_minx;
              ypos:=ypos-dev_ysize;
            end;
  newpage : begin
              uwriteln(outfile,'\page');
              xpos:=dev_minx;
              ypos:=dev_miny;
            end;
  exit    : begin
              uwriteln(outfile,'}');
              close(outfile);
            end;
  end;
end;


  {----------------------------------------}
  {   POSTSCRIPT  specific section         }
  {----------------------------------------}

procedure menu_postscript( var ps          : psrecord;
                           var lc          : boolean;
                           txt             : txtstring;
                           parstring       : parstringtype);
			   
var code     : char;
    instring : string40 ;

begin
  if interactflag then begin
    writeln;
    writeln('----------------------------------------------------------------');
    writeln('Enter the text attributes for printing of **>',txt,'<** residues:');
    writeln('First choose the color/gray-value of the letter **>background<**');
    writeln('Different letters specify different colors,');
    writeln('(B) black  (W) white (1,2,3,4) 4 different gray values, 4 is darkest');
    writeln;
    write('choose from  BW1234 ( * ',parstring[1],' * ) : ');
    readln(instring);
  end else instring:='';
  if instring='' then code:=parstring[1] else code:=instring[1];
  code:=upcase(code);
  case code of
  'B' : ps.bgnd:=0;
  'W' : ps.bgnd:=1;
  '1' : ps.bgnd:=0.8;
  '2' : ps.bgnd:=0.6;
  '3' : ps.bgnd:=0.4;
  '4' : ps.bgnd:=0.2; 
  end;
  if interactflag then begin
    writeln;
    writeln;
    writeln('Now choose the color/gray-value of the letter **>foreground<**');
    writeln('lowercase choices mean lowercase letters in the sequence:');
    writeln('(B,b) black  (W,w) white  (1,2,3,4) 4 different gray values, 4 is darkest');
    writeln('                          (5,6,7,8) same, but lowercase letters');
    writeln;
    write('choose from  BbWw12345678 ( * ',parstring[2],' * ) : ');
    readln(instring);
  end else instring:='';
  if instring='' then code:=parstring[2] else code:=instring[1];
  if code=upcase(code) then lc:=false else lc:=true;
  if code in ['1','2','3','4'] then lc:=false;
  code:=upcase(code);
  case code of
  'B' : ps.fgnd:=0;
  'W' : ps.fgnd:=1;
  '1','5' : ps.fgnd:=0.8;
  '2','6' : ps.fgnd:=0.6;
  '3','7' : ps.fgnd:=0.4;
  '4','8' : ps.fgnd:=0.2;
  end;
end;

procedure ask_postscript;
var parstring : parstringtype;
    instring  : string40;
    nametag   : string20;
begin
  if interactflag then
    writeln('----------------------------------------------------------------');
  reset(parfile);
  nametag:=':POSTSCRIPT';
  repeat readln(parfile,line) until indx(line,nametag)=1;
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  menu_postscript(ps[0],lc[0],'normal',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  menu_postscript(ps[1],lc[1],'identical',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  if simflag then menu_postscript(ps[2],lc[2],'similar',parstring) else begin
    ps[2]:=ps[0];
    lc[2]:=lc[0];
  end;
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  if globalflag then menu_postscript(ps[3],lc[3],'conserved',parstring)
  else begin
    ps[3]:=ps[1];
    lc[3]:=lc[1];
  end;
  readln(parfile,pscell);
  readln(parfile,parstring);
  if parstring[1] in ['y','Y'] then landscapeflag:=true
                               else landscapeflag:=false;
  if interactflag then begin
    repeat
      write('Character size in Points ( * ',pscell:4:1,' * ) : ');
      readln(instring);
      if instring<>'' then pscell:=str2int(instring);
    until (pscell>=1) and (pscell<=100);
    if landscapeflag then write('Rotate plot  ( * y * ) : ')
                     else write('Rotate plot  ( * n * ) : ');
    readln(instring);
    if instring<>'' then if instring[1] in ['y','Y'] then landscapeflag:=true
                                                     else landscapeflag:=false;
  end;
  if not cloutflag then begin
    write('filename for POSTSCRIPT-output  : ');
    readln(outname);
  end;
end;

procedure postscript  (    action          : actiontype;
                       var xpos,ypos       : real;
                           c               : char;
                           colno           : integer);
begin
  case action of
  init : begin
           if landscapeflag then begin
             dev_miny:=30;       { borders of a A4 page in point units }
             dev_minx:=30;
             dev_maxy:=545;
             dev_maxx:=800;
           end else begin
             dev_minx:=30;       { borders of a A4 page in point units }
             dev_miny:=20;
             dev_maxx:=575;
             dev_maxy:=760;
           end;
           dev_xsize:=pscell*0.7; { cells do overlap in x-direction }
           dev_ysize:=pscell;      
           xpos:=dev_minx;
           ypos:=dev_maxy;     { 0,0 is lower left corner }
           fopen(outfile,outname,'w');
           uwriteln(outfile,'%! ');
           uwriteln(outfile,'%%Creator: BOXshade 2.7');
           uwriteln(outfile,'%%Title: BOXSHADE document '+inname+
                           ' page:'+int2str(act_page,2));
           uwriteln(outfile,'save initgraphics');
           uwriteln(outfile,'/Courier-Bold findfont '+real2str(pscell,5,1)+
                           ' scalefont setfont');
           if landscapeflag then begin
             uwriteln(outfile,'575 0 translate 90 rotate');
           end;
           uwriteln(outfile,'/pp { pop pop } bind def');
           uwriteln(outfile,'% output char in box');
           uwriteln(outfile,'% requires on stack: charcolor/cellcolor/x/y/(C)');
           uwriteln(outfile,'% Courier-Bold cellborders: (-30;-210) (630;780)');
           uwriteln(outfile,'/bx {');
           uwriteln(outfile,'  3 1 roll moveto');
           uwriteln(outfile,'  gsave');
           write   (outfile,'   ', -0.03*pscell:5:1,' ',-0.05*pscell:5:1,
                           '  rmoveto');
           uwriteln(outfile,'');
           write   (outfile,'   ',0.7*pscell:5:1,' 0 rlineto 0 ',pscell:5:1,
                           ' rlineto ',-0.7*pscell:5:1,' 0 rlineto closepath');
           uwriteln(outfile,'');
           uwriteln(outfile,'    1 index setgray fill');
           uwriteln(outfile,'  grestore');
           uwriteln(outfile,'  2 index setgray 0 2 rmoveto show ');
           uwriteln(outfile,'} bind def');
           uwriteln(outfile,'% fine grain grayscales for laserprinter');
           uwriteln(outfile,'120 currentscreen 3 -1 roll pop setscreen');
           uwriteln(outfile,'% dummy color initialization');
           uwriteln(outfile,'0 1');
         end;
  setcol : begin
             write(outfile,'pp ',ps[colno].fgnd:4:1,ps[colno].bgnd:4:1);
           end;
  charout : begin
              write(outfile,xpos:6:1,' ',ypos:6:1);
              uwriteln(outfile,' ('+c+') bx');
              xpos:=xpos+dev_xsize;
            end;
  newline : begin
              xpos:=dev_minx;
              ypos:=ypos-dev_ysize;
            end;
  newpage : begin
              uwriteln(outfile,'copypage erasepage');
              xpos:=dev_minx;
              ypos:=dev_maxy;
            end;
  exit    : begin
              uwriteln(outfile,'pp restore showpage');
              close(outfile);
            end;
  end;
end;


procedure eps         (    action          : actiontype;
                       var xpos,ypos       : real;
                           c               : char;
                           colno           : integer);
var
    bbox_x0,
    bbox_x1,
    bbox_y0,
    bbox_y1 : real;

begin
  case action of
  init : begin
           if landscapeflag then begin
             dev_miny:=30;       { borders of a A4 page in point units }
             dev_minx:=30;
             dev_maxy:=545;
             dev_maxx:=800;
           end else begin
             dev_minx:=30;       { borders of a A4 page in point units }
             dev_miny:=20;
             dev_maxx:=575;
             dev_maxy:=760;
           end;
           dev_xsize:=pscell*0.7; { cells do overlap in x-direction }
           dev_ysize:=pscell;      
           xpos:=dev_minx;
           ypos:=dev_maxy;     { 0,0 is lower left corner }
           fopen(outfile,outname,'w');
           rewrite(outfile);
           uwriteln(outfile,'%!PS-Adobe-2.0 EPSF-2.0');
           if landscapeflag then begin
             bbox_x0:=dev_miny;
             bbox_y0:=dev_minx;
             bbox_x1:=dev_maxy-(no_blocks*(no_seq+interlines)*dev_ysize);
             bbox_y1:=dev_maxx;
           end else begin
             bbox_x0:=dev_minx;
             bbox_y0:=dev_maxy-(no_blocks*(no_seq+interlines)*dev_ysize);
             bbox_x1:=dev_maxx;
             bbox_y1:=dev_maxy;
           end;
           write   (outfile,'%%BoundingBox: ',bbox_x0:6:1,bbox_y0:6:1,
                                             bbox_x1:6:1,bbox_y1:6:1);
           uwriteln(outfile,'');
           uwriteln(outfile,'%%Creator: BOXshade 2.7');
           uwriteln(outfile,'%%Title: BOXSHADE document '+inname);
           uwriteln(outfile,'save');
           write   (outfile,'/Courier-Bold findfont ',pscell:5:1,
                           ' scalefont setfont');
           uwriteln(outfile,'');
           if landscapeflag then begin
             uwriteln(outfile,'575 0 translate 90 rotate');
           end;
           uwriteln(outfile,'/pp { pop pop } bind def');
           uwriteln(outfile,'% output char in box');
           uwriteln(outfile,'% requires on stack: charcolor/cellcolor/x/y/(C)');
           uwriteln(outfile,'% Courier-Bold cellborders: (-30;-210) (630;780)');
           uwriteln(outfile,'/bx {');
           uwriteln(outfile,'  3 1 roll moveto');
           uwriteln(outfile,'  gsave');
           write   (outfile,'   ', -0.03*pscell:5:1,' ',-0.05*pscell:5:1,
                           '  rmoveto');
           uwriteln(outfile,'');
           write   (outfile,'   ',0.7*pscell:5:1,' 0 rlineto 0 ',pscell:5:1,
                           ' rlineto ',-0.7*pscell:5:1,' 0 rlineto closepath');
           uwriteln(outfile,'');
           uwriteln(outfile,'    1 index setgray fill');
           uwriteln(outfile,'  grestore');
           uwriteln(outfile,'  2 index setgray 0 2 rmoveto show ');
           uwriteln(outfile,'} bind def');
           uwriteln(outfile,'% fine grain grayscales for laserprinter');
           uwriteln(outfile,'120 currentscreen 3 -1 roll pop setscreen');
           uwriteln(outfile,'% dummy color initialization');
           uwriteln(outfile,'0 1');
         end;
  setcol : begin
             write(outfile,'pp ',ps[colno].fgnd:4:1,ps[colno].bgnd:4:1);
           end;
  charout : begin
              write(outfile,xpos:6:1,' ',ypos:6:1);
              uwriteln(outfile,' ('+c+') bx');
              xpos:=xpos+dev_xsize;
            end;
  newline : begin
              xpos:=dev_minx;
              ypos:=ypos-dev_ysize;
            end;
  newpage : begin
              xpos:=dev_minx;
              ypos:=ypos-dev_ysize;
            end;
  exit    : begin
              uwriteln(outfile,'pp restore');
              close(outfile);
            end;
  end;
end;

  {----------------------------------------}
  {   HPGL  specific section               }
  {----------------------------------------}

procedure menu_hpgl      ( var hpglrec     : hpglrecord;
                           var lc          : boolean;
                           txt             : txtstring;
                           parstring       : parstringtype);
			   
var code1,code2   : char;
    instring      : string40;

begin
  if interactflag then begin
    writeln;
    writeln('-------------------------------------------------------------');
    writeln('Enter the text attributes for printing of **>',txt,'<** residues:');
    writeln('First choose color and hatching type of the letter **>background<**');
    writeln('NUMBERS specify plotter Pens,');
    writeln('LETTERS specify hatching types.');
    writeln('input has to be composed of a number and a letter');
    writeln('1-9, 0 : PEN No. (0 means no background)');
    writeln('(N) : no hatching  (S) : slash');
    writeln('(C) : crosshatch   (F) : fill');
    writeln;
    write('choose a number and a letter ( * ',parstring[1],parstring[2],' * ) : ');
    readln(instring);
  end else instring:='';
  if instring='' then begin
    code1:=parstring[1];
    code2:=parstring[2];
  end else begin
    code1:=instring[1];
    code2:=instring[2];
  end;
  code1:=upcase(code1); code2:=upcase(code2);
  case code2 of
  'N' : hpglrec.hatch:='';
  'S' : hpglrec.hatch:='3,0.8,45';
  'C' : hpglrec.hatch:='4,0.8,0';
  'F' : hpglrec.hatch:='1';
  end;
  hpglrec.bgnd:=str2int(code1);
  if interactflag then begin
    writeln;
    writeln;
    writeln('Enter the text attributes for printing of **>',txt,'<** residues:');
    writeln('Now choose color and case of the letter **>foreground<**');
    writeln('NUMBERS specify plotter Pens,');
    writeln('A letter "n" behind the number means "normal printing"');
    writeln('A letter "l" behind the number means "lowercase printing"');
    writeln('1-9, 0 : PEN No. (0 means no printing)');
    writeln('e.g. "1n" means : PEN #1 is to be used');
    writeln('e.g. "2l" means : PEN #2 and lowercase types are to be used');
    writeln;
    write('choose a number and a letter ( * ',parstring[3],parstring[4],' * ) : ');
    readln(instring);
  end else instring:='';
  if instring='' then begin
    code1:=parstring[3];
    code2:=parstring[4];
  end else begin
    code1:=instring[1];
    code2:=instring[2];
  end;
  if code2 in ['l','L'] then lc:=true else lc:=false;
  hpglrec.fgnd:=str2int(code1);
end;

procedure ask_hpgl;
var parstring : parstringtype;
    instring  : string40;
    nametag   : string10;
begin
  if interactflag then
    writeln('-----------------------------------------------------------------------');
  reset(parfile);
  nametag:=':HPGL';
  repeat readln(parfile,line) until indx(line,nametag)=1;
  readln(parfile,parstring);parstring:=substr(parstring,1,4);
  menu_hpgl(hpglrec[0],lc[0],'normal',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,4);
  menu_hpgl(hpglrec[1],lc[1],'identical',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,4);
  if simflag then menu_hpgl(hpglrec[2],lc[2],'similar',parstring) else begin
    hpglrec[2]:=hpglrec[0];
    lc[2]:=lc[0];
  end;
  readln(parfile,parstring);parstring:=substr(parstring,1,4);
  if globalflag then menu_hpgl(hpglrec[3],lc[3],'conserved',parstring)
  else begin
    hpglrec[3]:=hpglrec[1];
    lc[3]:=lc[1];
  end;
  readln(parfile,hpglcell);
  readln(parfile,parstring);
  if parstring[1] in ['y','Y'] then landscapeflag:=true
                               else landscapeflag:=false;
  if interactflag then begin
    repeat
      write('Character size in Points ( * ',hpglcell:4:1,' * ) : ');
      readln(instring);
      if instring<>'' then hpglcell:=str2int(instring);
    until (hpglcell>=1) and (hpglcell<=100);
    if landscapeflag then write('Rotate plot  ( * y * ) : ')
                     else write('Rotate plot  ( * n * ) : ');
    readln(instring);
    if instring<>'' then if instring[1] in ['y','Y']
                                  then landscapeflag:=true
                                  else landscapeflag:=false;
  end;
  if not cloutflag then begin
    write('filename for HPGL-output  : ');
    readln(outname);
  end;
end;

procedure hpgl  (          action          : actiontype;
                       var xpos,ypos       : real;
                           c               : char;
                           colno           : integer);
var xd,yd : real;
begin
  case action of
  init : begin
           if landscapeflag then begin
             dev_minx:=10.75;       { borders of a A4 page in mm }
             dev_miny:=5.0;
             dev_maxx:=260.75;
             dev_maxy:=185.0;
           end else begin
             dev_minx:=5.0;       { borders of a A4 page in mm }
             dev_miny:=10.75;
             dev_maxx:=185.0;
             dev_maxy:=260.75;
           end;
           dev_xsize:=hpglcell*0.351;
           dev_ysize:=hpglcell*0.351*2.0/1.5;
           hpglpen:=0;
           hpglhatch:='';
           xpos:=dev_minx;
           ypos:=dev_maxy;     { 0,0 is lower left corner }
           fopen(outfile,outname,'w');
           xd:=dev_xsize*100/1.5/(dev_maxx-dev_minx);
           yd:=dev_ysize*100/2.0/(dev_maxy-dev_miny);
           if landscapeflag
             then uwriteln(outfile,'IN;IP;SI'
                                   +real2str(hpglcell*0.351,5,3))
             else uwriteln(outfile,'IN;RO 90;IP;SI'
                                   +real2str(hpglcell*0.351,5,3));
           write(outfile,'SC',dev_minx:8:2,dev_maxx:8:2,
                              dev_miny:8:2,dev_maxy:8:2,';');
           uwriteln(outfile,'');
           write(outfile,'SR',xd:7:4,',',yd:7:4,';');
           uwriteln(outfile,'');
           uwriteln(outfile,'PU;');
         end;
  setcol : begin
             acthpgl:=hpglrec[colno];
           end;
  charout : begin
              if acthpgl.bgnd>0 then begin
                write(outfile,'PA',(xpos-0.125*dev_xsize):6:2,',',
                                   (ypos-0.25*dev_ysize):6:2,';');
                uwriteln(outfile,'');
                if acthpgl.bgnd<>hpglpen then begin
                  hpglpen:=acthpgl.bgnd;
                  write(outfile,'SP',hpglpen:1,';');
                end;
                if acthpgl.hatch<>hpglhatch then begin
                  hpglhatch:=acthpgl.hatch;
                  write(outfile,'FT',hpglhatch,';');
                end;
                write(outfile,'RR',dev_xsize:6:2,',',dev_ysize:6:2,';');
                uwriteln(outfile,'');
                write(outfile,'PR',(0.125*dev_xsize):6:2,',',
                                    (0.25*dev_ysize):6:2,';');
                uwriteln(outfile,'');
              end
              else begin
                write(outfile,'PA',xpos:6:2,',',ypos:6:2,';');
                uwriteln(outfile,'');
              end;
              if acthpgl.fgnd<>hpglpen then begin
                hpglpen:=acthpgl.fgnd;
                write(outfile,'SP',hpglpen:1,';');
              end;
              write(outfile,'LB',c,chr(3),';');
              uwriteln(outfile,'');
              xpos:=xpos+dev_xsize;
            end;
  newline : begin
              xpos:=dev_minx;
              ypos:=ypos-dev_ysize;
            end;
  newpage : begin
              uwriteln(outfile,'PG');
              xpos:=dev_minx;
              ypos:=dev_maxy;
              uwriteln(outfile,'PU;');
            end;
  exit    : begin
              uwriteln(outfile,'PG');
              close(outfile);
            end;
  end;
end;

{--------------------------------------------------------------------------}
{   LJ250 specific section                                                 }
{--------------------------------------------------------------------------}

procedure menu_lj250(var pre       : prestring;
                     var lc        : boolean;
                         txt       : txtstring;
                         parstring : parstringtype);
var code     : char;
    instring : string50;
begin
  if interactflag then begin
    writeln(' '); 
    writeln('-------------------------------------------------------------');
    writeln('Enter the text attributes for printing of >',txt,'< residues:');
    writeln('Different letters specify different colors,');
    writeln('lowercase choices mean lowercase residues:');
    writeln('(B,b) black,normal    (E,e) black, emphasized    (L,l) Blue');
    writeln('(C,c) Cyan (M,m) Magenta (Y,y) Yellow (G,g) Green (R,r) Red');
    writeln(' '); 
    write('choose from BbEeLlCcMmYyGgRr (* ',parstring[1],' *) : ');
    readln(instring);
  end else instring:='';
  if instring='' then code:=parstring[1] else code:=instring[1];
  if code=lowcase(code) then lc:=true else lc:=false;
  code:=lowcase(code);
  case code of
   'b' : pre:= chr(155)+'0m';
   'e' : pre:= chr(155)+'0;1m';
   'l' : pre:= chr(155)+'0;34m';
   'c' : pre:= chr(155)+'0;36m';
   'm' : pre:= chr(155)+'0;35m';
   'y' : pre:= chr(155)+'0;33m';
   'g' : pre:= chr(155)+'0;32m';
   'r' : pre:= chr(155)+'0;31m';
  end;
end;

procedure ask_lj250;
var parstring : parstringtype;
begin
  reset(parfile);
  repeat readln(parfile,line) until indx(line,':LJ250')=1;
  if interactflag then
    writeln('-------------------------------------------------------------');
  pre_reset:=chr(155)+'0m';
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  menu_lj250(pre[0],lc[0],'normal',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  menu_lj250(pre[1],lc[1],'identical',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  if simflag then begin
    menu_lj250(pre[2],lc[2],'similar',parstring) 
  end else begin
    pre[2]:=pre[0];
    lc[2]:=lc[0];
  end;
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  if globalflag then begin
    menu_lj250(pre[3],lc[3],'conserved',parstring) 
  end else begin
    pre[3]:=pre[1];
    lc[3]:=lc[1];
  end;
  if not cloutflag then begin
    write('name of print-file  : ');
    readln(outname);
  end;
end;

procedure lj250  (    action    : actiontype;
                  var xpos,ypos : real;
                      c         : char;
                      colno     : integer);
begin
  case action of
  init : begin
           fopen(outfile,outname,'w');
           write(outfile,pre_reset);
           dev_minx:=0;
           dev_miny:=1;
           dev_maxx:=80;
           dev_maxy:=63;
           dev_xsize:=1;
           dev_ysize:=1;
           xpos:=dev_minx;
           ypos:=dev_miny;
         end;
  setcol : begin
             write(outfile,pre[colno]);
           end;
  charout : begin
              write(outfile,c);
              xpos:=xpos+dev_xsize;
            end;
  newline : begin
              uwriteln(outfile,'');
              xpos:=dev_minx;
              ypos:=ypos+dev_ysize;
            end;
  newpage : begin
              uwriteln(outfile,chr(12));
              xpos:=dev_minx;
              ypos:=dev_miny;
            end;
  exit    : begin
              close(outfile);
            end;
  end;
end;
 
{--------------------------------------------------------------------------}
{   VT-Terminal specific section                                                 }
{--------------------------------------------------------------------------}

procedure menu_vt(var pre       : prestring;
                  var lc        : boolean;
                      txt       : txtstring;
                      parstring : parstringtype);
var code     : char;
    instring : string50;
begin
  if interactflag then begin
    writeln(' '); 
    writeln('-------------------------------------------------------------');
    writeln('Enter the text attributes for printing of >',txt,'< residues:');
    writeln('Different letters specify renditions,');
    writeln('lowercase choices mean lowercase residues:');
    writeln('(N,n) normal    (B,b) bold   (U,u) underscore  (R,r) reverse');
    writeln('(F,f) flashing  (E,e) reverse/bold (L,l) reverse/flashing');
    writeln(' '); 
    write('choose from NnBbUuRrFfEeLl (* ',parstring[1],' *) : ');
    readln(instring);
  end else instring:='';
  if instring='' then code:=parstring[1] else code:=instring[1];
  if code=lowcase(code) then lc:=true else lc:=false;
  code:=lowcase(code);
  case code of
   'n' : pre:= chr(27)+'[0m';
   'b' : pre:= chr(27)+'[0;1m';
   'u' : pre:= chr(27)+'[0;4m';
   'r' : pre:= chr(27)+'[0;7m';
   'e' : pre:= chr(27)+'[0;1;7m';
   'l' : pre:= chr(27)+'[0;5;7m';
   'f' : pre:= chr(27)+'[0;5m';
  end;
end;

procedure ask_vt;
var parstring : parstringtype;
begin
  reset(parfile);
  repeat readln(parfile,line) until indx(line,':VT')=1;
  if interactflag then
    writeln('--------------------------------------------------------------');
  pre_reset:=chr(27)+'[0m';
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  menu_vt(pre[0],lc[0],'normal',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  menu_vt(pre[1],lc[1],'identical',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  if simflag then begin
    menu_vt(pre[2],lc[2],'similar',parstring) 
  end else begin
    pre[2]:=pre[0];
    lc[2]:=lc[0];
  end;
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  if globalflag then begin
    menu_vt(pre[3],lc[3],'conserved',parstring) 
  end else begin
    pre[3]:=pre[1];
    lc[3]:=lc[1];
  end;
  if not cloutflag then begin
    write('filename for VT-output (return for terminal)  : ');
    readln(outname);
  end;
end;

procedure vt  (    action    : actiontype;
               var xpos,ypos : real;
                   c         : char;
                   colno     : integer);


begin
  case action of
  init : begin
           fopen(outfile,outname,'w');
           write(outfile,chr(27)+'[2J'+chr(27)+'[0;0H');
           write(outfile,pre_reset);
           dev_minx:=0;
           dev_miny:=1;
           dev_maxx:=80;
           dev_maxy:=25;
           dev_xsize:=1;
           dev_ysize:=1;
           xpos:=dev_minx;
           ypos:=dev_miny;
         end;
  setcol : begin
             write(outfile,pre[colno]);
           end;
  charout : begin
              write(outfile,c);
              xpos:=xpos+dev_xsize;
            end;
  newline : begin
              uwriteln(outfile,'');
              xpos:=dev_minx;
              ypos:=ypos+dev_ysize;
            end;
  newpage : begin
              write(chr(7));
              readln;
              uwriteln(outfile,chr(12));
              xpos:=dev_minx;
              ypos:=dev_miny;
            end;
  exit    : begin
              uwriteln(outfile,pre_reset);
              close(outfile);
            end;
  end;
end;
 

{--------------------------------------------------------------------------}
{   ReGIS specific section                                                 }
{--------------------------------------------------------------------------}

procedure menu_regis( var regstr      : regisstring;
                      var lc          : boolean;
                      txt             : txtstring;
                      parstring       : parstringtype);
var p        : integer;
    code     : char;
    instring : string50;
begin
  regstr:='';
  if interactflag then begin
    writeln(' ');
    writeln('-----------------------------------------------------------------------'); 
    writeln('Enter the text attributes for printing of **>',txt,'<** residues:');
    writeln('First choose the color/gray-value of the letter **>background<**');
    writeln('Different letters specify different colors,');
    writeln('(B) black  (W) white       (L) Blue (G) Green   (R) Red');
    writeln('                           (C) Cyan (M) Magenta (Y) Yellow ');
    writeln('(1,2,3,4) 4 different gray values, 4 is darkest');
    writeln(' ');
    write('choose from  BWLGRCMY1234 (* ',parstring[1],' *) : ');
    readln(instring);
  end else instring:='';
  if instring='' then code:=parstring[1] else code:=instring[1];
  code:=lowcase(code);
  case code of
  'b' : regstr:=regstr+'S(I(D));';
  'w' : regstr:=regstr+'S(I(W));';
  'l' : regstr:=regstr+'S(I(B));';
  'g' : regstr:=regstr+'S(I(G));';
  'r' : regstr:=regstr+'S(I(R));';
  'c' : regstr:=regstr+'S(I(C));';
  'm' : regstr:=regstr+'S(I(M));';
  'y' : regstr:=regstr+'S(I(Y));';
  '1' : regstr:=regstr+'S(I(H0L80S0));';
  '2' : regstr:=regstr+'S(I(H0L60S0));';
  '3' : regstr:=regstr+'S(I(H0L40S0));';
  '4' : regstr:=regstr+'S(I(H0L20S0));';
  end;
  if interactflag then begin
    writeln;
    writeln;
    writeln('Now choose the color/gray-value of the letter **>foreground<**');
    writeln('lowercase choices mean lowercase letters in the sequence:');
    writeln('(B,b) black  (W,w) white   (L,l) Blue  (G,g) Green  (R,r) Red');
    writeln('(C,c) Cyan   (M,m) Magenta (Y,y) Yellow ');
    writeln('(1,2,3,4) 4 different gray values, 4 is darkest');
    writeln('(5,6,7,8) 4 different gray values, 8 is darkest, but lowercase letters');
    writeln;
    write('choose from  BWLGRCMY1234/bwlgrcmy5678 (* ',parstring[2],' *) : ');
    readln(instring);
    writeln;
    writeln;
  end else instring:='';
  if instring='' then code:=parstring[2] else code:=instring[1];
  if code=lowcase(code) then lc:=true else lc:=false;
  if code in ['1','2','3','4'] then lc:=false;
  code:=lowcase(code);
  case code of
  'b' : regstr:=regstr+'W(I(D));';
  'w' : regstr:=regstr+'W(I(W));';
  'l' : regstr:=regstr+'W(I(B));';
  'g' : regstr:=regstr+'W(I(G));';
  'r' : regstr:=regstr+'W(I(R));';
  'c' : regstr:=regstr+'W(I(C));';
  'm' : regstr:=regstr+'W(I(M));';
  'y' : regstr:=regstr+'W(I(Y));';
  '1','5' : regstr:=regstr+'W(I(H0L80S0));';
  '2','6' : regstr:=regstr+'W(I(H0L60S0));';
  '3','7' : regstr:=regstr+'W(I(H0L40S0));';
  '4','8' : regstr:=regstr+'W(I(H0L20S0));';
  end;
end;

procedure ask_regis;
var parstring : parstringtype;
begin
  if interactflag then
    writeln('-----------------------------------------------------------------------'); 
  reset(parfile);
  repeat readln(parfile,line) until indx(line,':ReGIS')=1;
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  menu_regis(regstr[0],lc[0],'normal',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  menu_regis(regstr[1],lc[1],'identical',parstring);
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  if simflag then menu_regis(regstr[2],lc[2],'similar',parstring)
  else begin
    regstr[2]:=regstr[0];
    lc[2]:=lc[0];
  end;
  readln(parfile,parstring);parstring:=substr(parstring,1,2);
  if globalflag then menu_regis(regstr[3],lc[3],'conserved',parstring) 
  else begin
    regstr[3]:=regstr[1];
    lc[3]:=lc[1];
  end;
  if not cloutflag then begin
    write('filename for REGIS-output  : ');
    readln(outname);
  end;
end;

procedure regis  (    action    : actiontype;
                  var xpos,ypos : real;
                      c         : char;
                      colno     : integer;
                      regmode   : regmodetype);

begin
  case action of
  init : begin
           dev_minx:=0;
           dev_miny:=0;
           dev_maxx:=799;
           if regmode = rTERM 
             then dev_maxy:=479 
             else dev_maxy:=1199;
           dev_xsize:=9;
           dev_ysize:=20;
           fopen(outfile,outname,'w');
           uwriteln(outfile,chr(27)+'[?38l'+chr(27)+'Pp');
           write(outfile,'S(I(W)E);S(C0);S(A[0,0][',
                            round(dev_maxx),',',round(dev_maxy),']);');
           uwriteln(outfile,'');
           uwriteln(outfile,'P[0,0];W(R);T(S1)');
           xpos:=dev_minx;
           ypos:=dev_miny;
         end;
  setcol : begin
             write(outfile,regstr[colno]);
           end;
  charout : begin
              uwriteln(outfile,'T"'+c+'";');
              xpos:=xpos+dev_xsize;
            end;
  newline : begin
              xpos:=dev_minx;
              ypos:=ypos+dev_ysize;
              write(outfile,'P[0,',round(ypos),'];');
              uwriteln(outfile,'');
            end;
  newpage : begin
              if regmode = rTERM then begin
                write(chr(7));
                readln;
              end;
              write(outfile,'S(FI(W)E);S(C0);S(A[0,0][',
                            round(dev_maxx),',',round(dev_maxy),']);');
                uwriteln(outfile,'');
              uwriteln(outfile,'P[0,0];W(R);T(S1)');
              xpos:=dev_minx;
              ypos:=dev_miny;
            end;
  exit    : begin
              uwriteln(outfile,chr(27)+'\'+chr(27)+'[23;1H');
              close(outfile);
            end;
  end;
end;


{$ifdef Borland_Pascal}
  begin
{$endif}


end.
