{$ifdef osf1}
 [environment ('bx_read.pen'), inherit ('dep_dec.pen','bx_types.pen')]
 module bx_read(input,output);
{$endif}

{$ifdef vms}
 [environment ('bx_read.pen'), inherit ('dep_vms.pen','bx_types.pen')]
 module bx_read(input,output);
{$endif}

{$ifdef Borland_Pascal}
  unit bx_read;
  INTERFACE
  uses dep_tp,bx_types;

  procedure read_file_clustal;
  procedure read_file_pretty; 
  procedure read_file_maligned;
  procedure read_file_esee;    
  procedure read_file_phylip;  

  IMPLEMENTATION

{$endif}

procedure read_file_clustal;
var i,j        : integer;
    infile     : text;
    nametag,
    emptytag   : string40;
    taglen,
    seqstart   : integer;
    emptycount : integer;

begin
  emptytag:=''; for i:=1 to seqnamelen do emptytag:=emptytag+' ';
  fopen(infile,inname,'r');
  no_seq:=0;
  emptycount:=0;
  repeat
    readln(infile,line);
    emptycount:=emptycount+1;
  until (length(line)<5);
  repeat
    readln(infile,line);
    emptycount:=emptycount+1;
  until (length(line)>12);
  taglen:=0;
  repeat
    if length(line)>12 then begin
      i:=1;
      repeat i:=i+1 until ((line[i]=' ' ) or (i=length(line)) );
      taglen:=i-1;
      repeat i:=i+1 until ((line[i]<>' ') or (i=length(line)) );
      if taglen<2 then begin 
        seqstart:=i;  {***** is that correct ??? *****}
        nametag:=emptytag 
      end else begin
        seqstart:=i;
        nametag:=substr(line,1,taglen);
      end;
    end else nametag:=emptytag;
    if nametag<>emptytag then begin
      no_seq:=no_seq+1;
      seqname[no_seq]:=emptytag;
      startno[no_seq]:=1;
      if taglen>seqnamelen then taglen:=seqnamelen;
      for i:=1 to taglen do seqname[no_seq,i]:=nametag[i];
    end;
    if not eof(infile) then readln(infile,line) else nametag:=emptytag;
  until (nametag=emptytag);
  reset(infile);
  for i:=1 to emptycount-1 do readln(infile,line);
  for i:=1 to no_seq do seqlen[i]:=0;
  while not eof(infile) do begin
    for i:=1 to no_seq do begin
      readln(infile,line);
      j:=1;
      while (seqstart-1+j)<=length(line) do begin
        seq[i,seqlen[i]+j]:=upcase(line[seqstart-1+j]);
        j:=j+1;
      end;
      seqlen[i]:=seqlen[i]+j-1;
    end;
    if not eof(infile) then readln(infile,dummystring);
    if not eof(infile) then readln(infile,dummystring);
  end;
end;


procedure read_file_pretty;
const
    blocklen      = 10;
    blockno       = 5;
    blockdist     = 1;
var
    blockstart : integer;
    i,j,k      : integer;
    infile     : text;
    offs       : integer;
    found      : boolean;
    nametag    : string255;
    tempname   : string255;
    emptytag   : string80;
    msfflag    : boolean;
begin
  fopen(infile,inname,'r');
  repeat readln(infile,line) until ((indx(line,'..')>0) or eof(infile));
  repeat readln(infile,line) until ((indx(line,'//')>0) or eof(infile));
  if not eof(infile)
  then begin
    msfflag:=true;
  end
  else begin
    msfflag:=false;
    reset(infile);            
    repeat readln(infile,line) until indx(line,'..')>0;
  end;
  readln(infile,dummystring);
  readln(infile,line);
  blockstart:=1;
  while line[blockstart]=' ' do blockstart:=blockstart+1;
  emptytag:='';
  for i:=1 to (blockstart-1) do emptytag:=emptytag+' ';
  no_seq:=0;

  while not eof(infile) do begin
    readln(infile,line);
    if (length(line)>=blockstart) and (substr(line,1,blockstart-1)<>emptytag)
    then begin
      tempname:='';
      i:=1;
      while line[i]=' ' do i:=i+1;
      while line[i]<>' ' do begin
        tempname:=tempname+line[i];
        i:=i+1;
      end;
      if no_seq=0 then begin
        no_seq:=1;
        seqname[1]:=tempname;
      end else begin
        found:=false;
        for i:=1 to no_seq do if tempname=seqname[i] then found:=true;
        if found=false then begin
          no_seq:=no_seq+1;
          seqname[no_seq]:=tempname;
        end;
      end;
    end;
  end;
  for i:=1 to no_seq do startno[i]:=1;

  reset(infile);
  repeat readln(infile,line) until indx(line,'..')>0;
  if msfflag then repeat readln(infile,line) until indx(line,'//')>0;
  readln(infile,dummystring);
  readln(infile,dummystring);
  offs:=1;
  repeat
    i:=1;
    if not eof(infile) then readln(infile,line);
    repeat
      if (length(line)>=blockstart) and (substr(line,1,blockstart-1)<>emptytag)
      then begin
        nametag:='';
        j:=1;
        while line[j]=' ' do j:=j+1;
        while line[j]<>' ' do begin
          nametag:=nametag+line[j];
          j:=j+1;
        end;
        while line[j]=' ' do j:=j+1;
        blockstart:=min(blockstart,j);
      end else nametag:='';
      if nametag<>seqname[i] then begin
        for j:=0 to blocklen*blockno-1 do seq[i,offs+j]:=' ';
      end else begin
        for j:=0 to (blockno-1) do begin
          for k:=0 to (blocklen-1) do begin
            if (blockstart+j*(blocklen+blockdist)+k)<=length(line) then
            seq[i,offs+j*blocklen+k]
               :=upcase(line[blockstart+j*(blocklen+blockdist)+k]);
          end;
        end;
        if not eof(infile) then readln(infile,line);
      end;
      i:=i+1;
    until i>no_seq;
    offs:=offs+blocklen*blockno;
    if not eof(infile) then readln(infile,dummystring);
  until eof(infile);
  for i:=1 to no_seq do begin
    seqlen[i]:=offs-1;
    if length(seqname[i])<seqnamelen then
      for j:=length(seqname[i])+1 to seqnamelen do seqname[i]:=seqname[i]+' ';
  end;
  close(infile);
end;

procedure read_file_maligned;
var i,j      : integer;
    infile   : text;
    emptytag : string255;

begin
  emptytag:=''; for i:=1 to seqnamelen do emptytag:=emptytag+' ';
  fopen(infile,inname,'r');
  no_seq:=0;
  readln(infile,line);                              {maligned internal line}
  readln(infile,line);                              { ditto }
  while not eof(infile) do begin
    readln(infile,line);                            {directory}
    if not eof(infile) then readln(infile,line);    {filename}
    if not eof(infile) then begin
      no_seq:=no_seq+1;
      seqname[no_seq]:=emptytag;
      readln(infile,line);                          {seqname}
      for i:=1 to min(length(line),seqnamelen) do
         seqname[no_seq,i]:=line[i];
      readln(infile,startno[no_seq]);               {seqstart, seqend}
      seqlen[no_seq]:=0;
      while (not eof(infile)) and (length(line)>0) do begin
        readln(infile,line);
        if length(line)>0 then begin
          for j:=1 to length(line) do begin
            seq[no_seq,seqlen[no_seq]+j]:=upcase(line[j]);
            seqlen[no_seq]:=seqlen[no_seq]+j;
	  end;
        end;
      end;
    end;
  end;
  close(infile);
end;

procedure read_file_esee;
var i,j          : integer;
    infile       : file of byte;
    emptytag     : string255;
    b            : byte;
    versno,snl   : byte;

begin
  emptytag:=''; for i:=1 to seqnamelen do emptytag:=emptytag+' ';
  { *** NOT PORTABLE ! **** }
{$ifdef Borland_Pascal}
  assign(infile,inname);
{$endif}
{$ifdef dec}
  open(infile,inname,readonly);
{$endif}
  reset(infile);
  read(infile,versno);
  read(infile,b); no_seq:=b;
  read(infile,b); no_seq:=no_seq+b*256;
  for i:=1 to no_seq do begin
    read(infile,b); seqlen[i]:=b;
    read(infile,b); seqlen[i]:=seqlen[i]+b*256-1;
    for j:=1 to seqlen[i] do begin
      read(infile,b);
      seq[i,j]:=upcase(chr(b));
    end;
    read(infile,b); if b<>1 then writeln('ESEE format error in seq:',i:2);
    read(infile,b); snl:=b;
    seqname[i]:=emptytag;
    startno[i]:=1;
    for j:=1 to 64 do begin
      read(infile,b);
      if (j<=snl) and (j<=seqnamelen) then seqname[i,j]:=chr(b);
    end;
    for j:=1 to 6 do read(infile,b);                        {linesum}
    for j:=1 to 6 do read(infile,b);                        {start}
    read(infile,b);                                         {type}
    read(infile,b);                                         {NrOFF}
    read(infile,b);                                         {reverse}
  end;
end;

procedure read_file_phylip;
var i,j        : integer;
    infile     : text;
    firstline  : boolean;

begin
  fopen(infile,inname,'r');
  reset(infile);
  no_seq:=0;
  firstline:=true;
  readln(infile,no_seq);
  while not eof(infile) do begin
    for i:=1 to no_seq do begin
      readln(infile,line);
      if firstline then begin
        startno[i]:=1;
        seqlen[i]:=0;
        seqname[i]:=substr(line,1,10);
        line:=substr(line,12,length(line)-11);
      end;
      for j:=1 to length(line) do begin
        if line[j]<>' ' then begin
          seqlen[i]:=seqlen[i]+1;
          seq[i,seqlen[i]]:=line[j];
        end;
      end;
    end;
    readln(infile,dummystring);
    firstline:=false;
  end;
  close(infile);
end;


{$ifdef Borland_Pascal}
  begin
{$endif}

end.
