{$ifdef osf1}
  [inherit ('dep_dec.pen'), environment ('bx_types.pen')]
  module bx_types;
{$endif}

{$ifdef vms}
  [inherit ('dep_vms.pen'), environment ('bx_types.pen')]
  module bx_types;
{$endif}

{$ifdef Borland_Pascal}
   unit bx_types;
   INTERFACE
   uses dep_tp;
{$endif}

const
       oPS     = '1';
       oEPS    = '2';
       oHPGL   = '3';
       oRTF    = '4';
       oCRT    = '5';
       oANSI   = '6';
       oVT     = '7';
       oREGISt = '8';
       oREGISp = '9';
       oLJ250  = 'a';
 
{$ifdef Borland_Pascal}
       allowed_devices = '123456789a';
       max_no_seq      = 15;
       max_no_res      = 1200;
{$endif}

{$ifdef dec}
       allowed_devices = '12346789a';
       max_no_seq      = 50;
       max_no_res      = 3000;
{$endif}

       max_no_block  = 50;
       max_outlen    = 255;
       max_linelen   = 255;  {defines linetype}
       seqnamelen    = 40;   {defines sseqnametype}
       seqnumlen     = 4;    {defines numtype}

       idpref        = 4;     {the quotient idpref/simpref is 4/1       }
       simpref       = 1;     {therefore 4 similarities are scored like }
                              {1 identity in consensus calculation      }

type
       byte          = 0..255;
       seqtype       = array[1..max_no_seq,1..max_no_res] of char;
       coltype       = array[1..max_no_seq,1..max_no_res] of byte;
       constype      = array[1..max_no_res] of char;
       linetype      = string255;
       sseqnametype  = string40;
       seqnametype   = array[1..max_no_Seq] of sseqnametype;
       numtype       = string4;
       cmptype       = array[1..20,1..20] of boolean;
       filenametype  = string255;
       prestring     = string20;
       txtstring     = string20;
       parstringtype = string5;
       regisstring   = string30;

       actiontype    = (init,setcol,charout,newline,newpage,exit);
       regmodetype   = (rTERM,rPAGE);
       cltagtype     = string10;
       cllinetype    = string80;


{       gra_dev_proc  = (pCRTOUT,pANSI,pPOSTSCRIPT,pEPS,pRTF,pHPGL,
                        pVT,pREGIS,pLJ250);
}       
       psrecord      = record
                         bgnd,fgnd : real;
                       end;
       crtrecord      = record
                         bgnd,fgnd : byte;
                       end;
       rtfrecord      = record
                         bgnd,fgnd : integer;
                       end;
       hpglrecord    = record
                         hatch : string10;
                         bgnd,fgnd : integer;
                       end;

var
       aaset         : string20;
       dummystring   : string80;
       errcode       : integer;     {turbo-specific IO-error indicator}
       seq           : seqtype;     {all sequences (characters)}
       consenslen    : integer;     {maximum sequence length   }
       seqlen        : array[1..max_no_seq] of integer;
                                    {all sequence lengths}
       startno       : array[1..max_no_seq] of integer;
                                    {all sequence starts}
       prenum        : array[1..max_no_seq,1..max_no_block] of numtype;
                                    {blocknumbers for output}
       col           : coltype;     {all sequences (cell colors)}
       cons          : constype;    {the consensus sequence}
       conschar      : constype;    {line for consensus display}
       seqname       : seqnametype; {all sequence names}
       line          : linetype;

       no_seq        : integer;     {how many sequences}
       outlen        : integer;     {length of an output block}
       seqname_outlen: integer;     {output length of seqnames}
       no_blocks     : integer;     {output how many blocks}
       blocks_per_page : integer;   {how many blocks per page}

       inname,outname,
       cmpname,
       parname       : filenametype;   {misc. filenames}
       parfile       : text;
       cmptable      : cmptype;

       outputmode    : char; {PS, EPS, HPGL, RTF, (CRT), ANSI, VT100, ReGISterm}
                             {ReGISprint, LJ250}
       inputmode     : char;        {1=Lineup, 2=Clustal, 3=Maligned, 4=ESEE}
       consensnum    : integer;     { sequence to make consensus to }

       lc            : array[0..3] of boolean;

       simflag,                              {mark similar residues?}
       globalflag    : boolean;              {mark globally consvd. residues?}
       interlines    : integer;              {how many lines between blocks}
       seqnameflag   : boolean;              {sequence names to be printed}
       seqnumflag    : boolean;              {position numbers to be printed}
       seqconsflag   : boolean;              {consensus to a master sequence}
       hideflag      : boolean;              {hide master sequence}
       dnaflag       : boolean;              {DNA or proteins to be aligned}
       interactflag  : boolean;              {interaction with user?}
       clinflag      : boolean;              {input filename  in commandline?}
       cloutflag     : boolean;              {output filename in commandline?}
       clparflag     : boolean;              {param filename in commandline?}
       cltypeflag    : boolean;              {input file type in comline?}
       cldevflag     : boolean;              {output device type in comline?}
       clsymbconsflag: boolean;              {symbcons defined in commandline?}
       consflag      : boolean;              {display consensus line?}
       splitflag     : boolean;              {multiple file output?}
       numdefflag    : boolean;              {default numbering?}
       unixflag      : boolean;              {write unix style?}
       symbcons      : array[1..3] of char;  {symbols for consensus}

       dev_maxx,                             {maximal device coordinates}
       dev_maxy      : real;
       dev_minx,                             {minimal device coordinates}
       dev_miny      : real;
       dev_xsize,                            {character sizes for device}
       dev_ysize     : real;
       act_color     : integer;              {actual color}
       act_page      : integer;              {actual page no}
       outfile       : text;

{       gra_dev_ptr   : gra_dev_proc;         graphics device procedure}

       pre_reset     : prestring;            { ANSI-specific vars }
       pre           : array[0..3] of prestring;

       ps            : array[0..3] of psrecord;      { POSTSCRIPT-specifics}
       pscell        : real;                         { character cell size }

       crtrec        : array[0..3] of crtrecord;     { CRT-specifics}

       hpglrec       : array[0..3] of hpglrecord;    { HPGL-specifics}
       hpglcell      : real;                         { character cell size }
       acthpgl       : hpglrecord;                   { actual values }
       hpglpen       : integer;                      { actual pen No. (1-8/0) }
       hpglhatch     : string10;                     { actual hatch type }

       rtfrec        : array[0..3] of rtfrecord;     {RTF-specifics}
       rtfcell       : integer;

       landscapeflag : boolean;

       regstr        : array[0..3] of regisstring;   {ReGIS-specifics}

{$ifdef Borland_Pascal}

  function min     (a,b : integer) : integer;

  IMPLEMENTATION
{$endif}

function min     (a,b : integer) : integer;
begin
  if a<b then min:=a else min:=b;
end;


{$ifdef dec}
 to begin do begin
     aaset:= 'ACDEFGHIKLMNPQRSTVWY';
 end;
{$endif}

{$ifdef Borland_Pascal}
  begin
     aaset:= 'ACDEFGHIKLMNPQRSTVWY';
{$endif}

 end.
